/* This program dgramsend sends a datagram to a receiver 
whose name is retrieved from the command line
argument. The form of the command line is: 
dgramsend hostname portnumber
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define DATA "Please echo the data ..."

main(argc, argv)
int argc;
char *argv[];
{
int sd, /* socket descriptor */
addrlen_server; /* length of address (sender) */

struct sockaddr_in server;
struct hostent *hp, *gethostbyname();

char buf[1024]; /* buffer for receiving data */

/* Create socket on which to send. */
sd = socket (AF_INET, SOCK_DGRAM, 0);
if (sd < 0)
{
perror("opening datagram socket");
exit(1);
}

/* Construct name with no wildcards, of the socket to
send to. gethostbyname returns a structure 
including the network address of the specified 
host.
The port number is taken from the command line.
*/

hp = gethostbyname(argv[1]);
if (hp == 0)
{
fprintf(stderr, "%s: unknown host\n", argv[1]);
exit(2);
}

server.sin_family = AF_INET;

/* Copy network address into server address. */

bcopy((char *)hp->h_addr, 
(char *)&server.sin_addr, 
hp->h_length);

/* Get port number from command line argument. */

server.sin_port = htons(atoi(argv[2]));

/* Send data. */
if (sendto( sd, DATA, sizeof(DATA), 0, 
(struct sockaddr *)&server, 
sizeof(server)) < 0)

{
perror("sending datagram message ");
exit(1);
}

/* Get back data (echo). */

if (recvfrom( sd, buf, sizeof(buf), 0, 
(struct sockaddr *)&server,
&addrlen_server) < 0)
{
perror("receiving datagram message ");
exit(1);
}
/* Close socket. */

close (sd);
exit(0);
}
