/* This program rlogin realize a remote login on another
machine which is retrieved from the command line 
argument. The form of the command line is: 
rlogin hostname 	
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

main(argc, argv) 
int argc;
char *argv[];
{
int sd; /* socket descriptor */
struct sockaddr_in server;
struct hostent *hp, *gethostbyname();
struct servent *sp, *getservbyname();

/* Create socket. */
sd = socket (AF_INET, SOCK_STREAM, 0);
if (sd < 0)
{
perror("rlogin: socket ");
exit(1);
}

/* Get destination host with gethostbyname()call. */
hp = gethostbyname(argv[1])
if (hp == 0)
{
fprintf(stderr, "%s: unknown host \n", argv[1]);
exit(2);
}

/* Locate the service definition for a 
remote login with getservbyname() call */

sp = getservbyname("login", "tcp");
if (sp == 0)
{
fprintf(stderr, "tcp login: unknown service \n");
exit(3);
}

server.sin_family = AF_INET;

/* Copy network address into server address. 	*/
bcopy((char *) hp->h_addr,
 (char*)&server.sin_addr,
hp->h_length);
/* Set port-number of server. */
server.sin_port = sp->s_port;
	
/* Connect to server; connect does bind for us. */
if (connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0)
{
perror ("rlogin: connect ");
exit(4);
}

/* Details of the remote login protocol will
not be considered here.*/
	
/* ...
*/

close(sd);
exit(0);

}
